import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Cliente extends JFrame{
	private JTextField campoIntroducir;
	private JTextArea areaPantalla;
	private ObjectOutputStream salida;
	private ObjectInputStream entrada;
	private String mensaje="";
	private String servidorChat;
	private Socket cliente;
	
	public Cliente(String host){
		
		super("Cliente Luigi Prez Calzada");
		servidorChat=host;
		Container contenedor=getContentPane();
		campoIntroducir=new JTextField();
		campoIntroducir.setEditable(false);
		campoIntroducir.addActionListener(
			new ActionListener(){
				public void actionPerformed(ActionEvent evento){
					enviarDatos(evento.getActionCommand());
					campoIntroducir.setText("");
				}
			}
		);
		contenedor.add(campoIntroducir, BorderLayout.NORTH);
		areaPantalla=new JTextArea();
		contenedor.add(new JScrollPane(areaPantalla),BorderLayout.CENTER);
		setSize(450,450);
		setVisible(true);
	}//cierre clase cliente
	
	private void ejecutarCliente(){
		try{
			conectarAServidor();
			obtenerFlujos();
			procesarConexion();
		}
		catch(EOFException exceptionEOF){
			System.err.println("El cliente termino la conexin");
		}
		catch(IOException exceptionES){
			exceptionES.printStackTrace();
		}
		finally{
			cerrarConexion();
		}
	}
	
	private void conectarAServidor() throws IOException{
		mostrarMensaje("Intentando realizar conexion: \n");
		cliente=new Socket(InetAddress.getByName(servidorChat),12345);
		mostrarMensaje("Conectado a: "+cliente.getInetAddress().getHostName());
	}
	
	private void obtenerFlujos() throws IOException{
		salida=new ObjectOutputStream(cliente.getOutputStream());
		salida.flush();
		entrada=new ObjectInputStream(cliente.getInputStream());
		mostrarMensaje("\nSe recibieron los flujos de E/S\n");
	}
	
	private void procesarConexion() throws IOException{
		establecerCampoTextoEditable(true);
		do{
			try{
				mensaje=(String)entrada.readObject();
				mostrarMensaje("\n"+mensaje);
			}
			catch(ClassNotFoundException exceptionClaseNoEncontrada){
				mostrarMensaje("\nSe recibio un objeto de tipo desconocido");
			}
		}
		while(!mensaje.equals("el Servidor dice:adios"));
	}
	
	private void cerrarConexion(){
		mostrarMensaje("\nCerrando conexin\n");
		establecerCampoTextoEditable(false);
		try{
			salida.close();
			entrada.close();
			cliente.close();
		}
		catch(IOException exceptionES){
			exceptionES.printStackTrace();
		}
	}
	
	private void enviarDatos(String mensaje){
		try{
			salida.writeObject("el Cliente dice:"+mensaje);
			salida.flush();
			mostrarMensaje("\nel Cliente dice:"+mensaje);
		}
		catch(IOException exceptionES){
			areaPantalla.append("\nError al escribir el objeto");
		}
	}
	
	private void mostrarMensaje(final String mensajeMostrar){
		SwingUtilities.invokeLater(
			new Runnable(){
				public void run(){
					areaPantalla.append(mensajeMostrar);
					areaPantalla.setCaretPosition(
						areaPantalla.getText().length());
				}
			}
		);
	}
	
	private void establecerCampoTextoEditable(final boolean editable){
		SwingUtilities.invokeLater(
			new Runnable(){
				public void run(){
					campoIntroducir.setEditable(editable);
				}
			}
		);
	}
	
	public static void main(String args[]){
		Cliente aplicacion;
		if(args.length==0)
			aplicacion=new Cliente("");
		else
			aplicacion=new Cliente(args[0]);
		aplicacion.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		aplicacion.ejecutarCliente();
	}
}//cierre programa principal