import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Servidor extends JFrame{
	private JTextField campoIntroducir;
	private JTextArea areaPantalla;
	private ObjectOutputStream salida;
	private ObjectInputStream entrada;
	private ServerSocket servidor;
	private Socket conexion;
	private int contador=1;
	
	public Servidor(){
		
		super("Servidor PuRaSLiNeAs punto com");
		Container contenedor=getContentPane();
		campoIntroducir=new JTextField();
		campoIntroducir.setEditable(false);
		campoIntroducir.addActionListener(
			new ActionListener(){
				public void actionPerformed(ActionEvent evento){
					enviarDatos(evento.getActionCommand());
					campoIntroducir.setText("");
				}
			}
		);
		contenedor.add(campoIntroducir, BorderLayout.NORTH);
		areaPantalla=new JTextArea();
		contenedor.add(new JScrollPane(areaPantalla),BorderLayout.CENTER);
		setSize(450,450);
		setVisible(true);
	}//cierre clase cliente
	
	private void ejecutarServidor(){
	try{
		servidor=new ServerSocket(12345,100);
		while(true){
			try{
				esperarConexion();
				obtenerFlujos();
				procesarConexion();
			}
			catch(EOFException exceptionEOF){
				System.err.println("El servidor termino la conexin de PurasLiNeAs");
			}
			finally{
				cerrarConexion();
				++contador;
			}
		}
	}
		catch(IOException exceptionES){
			exceptionES.printStackTrace();
		}
	}
	
	private void esperarConexion() throws IOException{
		mostrarMensaje("Esperando una conexion: \n");
		conexion=servidor.accept();
		mostrarMensaje("Conexion: "+contador+" recibida de: "+conexion.getInetAddress().getHostName());
	}
	
	private void obtenerFlujos() throws IOException{
		salida=new ObjectOutputStream(conexion.getOutputStream());
		salida.flush();
		entrada=new ObjectInputStream(conexion.getInputStream());
		mostrarMensaje("\nSe recibieron los flujos de E/S\n");
	}
	
	private void procesarConexion() throws IOException{
		String mensaje="Conexion exitosa";
		enviarDatos(mensaje);
		establecerCampoTextoEditable(true);
		do{
			try{
				mensaje=(String)entrada.readObject();
				mostrarMensaje("\n"+mensaje);
			}
			catch(ClassNotFoundException exceptionClaseNoEncontrada){
				mostrarMensaje("\nSe recibio un objeto de tipo desconocido");
			}
		}
		while(!mensaje.equals("el Cliente dice:adios"));
	}
	
	private void cerrarConexion(){
		mostrarMensaje("\nFinalizando la conexin\n");
		establecerCampoTextoEditable(false);
		try{
			salida.close();
			entrada.close();
			conexion.close();
		}
		catch(IOException exceptionES){
			exceptionES.printStackTrace();
		}
	}
	
	private void enviarDatos(String mensaje){
		try{
			salida.writeObject("el Servidor dice:"+mensaje);
			salida.flush();
			mostrarMensaje("\nel Servidor dice:"+mensaje);
		}
		catch(IOException exceptionES){
			areaPantalla.append("\nError al escribir el objeto");
		}
	}
	
	private void mostrarMensaje(final String mensajeMostrar){
		SwingUtilities.invokeLater(
			new Runnable(){
				public void run(){
					areaPantalla.append(mensajeMostrar);
					areaPantalla.setCaretPosition(
						areaPantalla.getText().length());
				}
			}
		);
	}
	
	private void establecerCampoTextoEditable(final boolean editable){
		SwingUtilities.invokeLater(
			new Runnable(){
				public void run(){
					campoIntroducir.setEditable(editable);
				}
			}
		);
	}
	
	public static void main(String args[]){
		Servidor aplicacion=new Servidor();
		aplicacion.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		aplicacion.ejecutarServidor();
	}
}//cierre programa principal